module Examples where

import Absy
import IMP

-- The factorial
p1 = Block [ Read "x"
           , "n" := Num 1
           , Print "Input: " (Var "x")
           , While (Less (Num 0) (Var "x")) $ 
                Block [ "n" := Times (Var "n") (Var "x")
                      , "x" := Minus (Var "x") (Num 1)
                      ]
           , Print "The result is " (Var "n")
           ]

-- Collatz conjecture 
p2 = Block [ Read "x"
           , "c" := Num 0
           , While BTrue $ 
               Block [ Print "Tracing: x= " (Var "x")
                     , If (Eq (Num 0) (Mod (Var "x") (Num 2)))
                          ("x" := Div (Var "x") (Num 2))
                          ("x" := Plus (Times (Var "x") (Num 3)) (Num 1))
                     , If (Eq (Var "x") (Num 1)) Break (Block [])
                     , "c" := Plus (Var "c") (Num 1)
                     ] 
           , Print "Number of steps: " (Var "c")
           ]
